/*
    Programa: xadez.exe
    Descrio: biblioteca necessria para criao da rvore de jogadas e execuo do algoritmo Minimax.
    Programador: Eduardo Prates Albuquerque
    RGM: 21500
    Data da ltima modificao: 24/09/2016
*/

#include "func.h"                   /*Chama as funes de movimento e validao de movimento*/
#include <stdlib.h>					/* sleep()*/
#include "xeque.h"                  /*Verificao de xeque e xeque mate*/
#include "arvore.h" 				/* escopo de funes, Defines*/
#include "conio_v3.2.4.h" 			/* Funo clrscr(), gotoxy() */


/*Esse procedimento  responsvel por inserir um novo n na rvore de jogadas*/
void cria_no (struct no **pt,int vez,int M[][8],int pos_pecas, int nivel_arvore)
{
int x,y; /*Auxiliares para loop*/
int xeque,atual_branco=0,atual_preto=0,mate=0, ameaca=0;
struct no *novo = NULL; /*Para criao de novo n na rvore*/

    /*Verifica se a raiz esta vazio. Caso sim, insere o novo n nessa posicao*/
    if((*pt)==NULL)
    {
        /*Cria o n*/
        novo = (Arvore *) malloc(sizeof(Arvore));
        novo->f1 = NULL;
        novo->f2 = NULL;
        novo->f3 = NULL;
        novo->f4 = NULL;
        novo->f5 = NULL;
        novo->f6 = NULL;
        novo->f7 = NULL;
        novo->f8 = NULL;
        novo->f9 = NULL;
        novo->f10 = NULL;
        novo->f11 = NULL;
        novo->f12 = NULL;
        novo->f13 = NULL;
        novo->f14 = NULL;
        novo->f15 = NULL;
        novo->f16 = NULL;
        novo->f17 = NULL;
        novo->f18 = NULL;
        novo->f19 = NULL;
        novo->f20 = NULL;

         /*Loop que pega a posio atual dos reis*/
        for (x=0;x<=7;x++)
        {
            for (y=0;y<=7;y++)
            {
                novo->tabuleiro[x][y]=M[x][y];
                if (novo->tabuleiro[x][y] ==60)
                {
                    atual_branco=x*10+y;
                }
                else if (novo->tabuleiro[x][y] ==61)
                {
                    atual_preto=x*10+y;
                }
            }
        }

        novo->TipoNo=vez;
        novo->jogada=pos_pecas;
        novo->avaliacao=0;
        novo->fim_jogo=0;
        novo->nivel_arvore=nivel_arvore;

        /*Insere a posio de sugesto de alterao*/
        if (pos_pecas != 0)
        {
            gotoxy(1,1);
            x=pos_pecas/100;
            y=pos_pecas%100;
            novo->tabuleiro[y/10][y%10]=novo->tabuleiro[x/10][x%10];
            novo->tabuleiro[x/10][x%10]=0;

            /*Verifica se o movimento sugerido foi feito pego rei. Caso sim, atualiza a posio do rei*/
            if (novo->tabuleiro[y/10][y%10] ==60)
            {
                atual_branco=y;
            }
            else if (novo->tabuleiro[y/10][y%10] ==61)
            {
                atual_preto=y;
            }


            /*Verifica Xeque*/
            for (x=0;x<=7;x++)
            {
                for (y=0;y<=7;y++)
                {
                    xeque=verifica_xeque(M,vez,x,y,atual_branco,atual_preto);
                    /*Condio em que o movimento do computador no deve ser validado, pois coloca o prprio rei em Xeque*/
                    if (xeque == -1)
                    {
                        mate= -1;
                        x=8;
                        y=8;
                    }
                    else
                    {
                        ameaca=xeque;
                    }
                }
            }

            if (mate == -1)
            {
                novo->fim_jogo=2;
            }
            /*Verifica se houve xeque mate para que o n no seja mais expandido*/
            else if (mate != -1)
            {
                ameaca=novo->jogada%100;
                if (vez ==0)
                {
                    mate=xeque_mate (novo->tabuleiro,ameaca,atual_preto,atual_branco,atual_preto);
                    if (mate == 0)
                    {
                        novo->fim_jogo=-1;
                    }
                }
                else
                {
                    mate=xeque_mate (novo->tabuleiro,ameaca,atual_branco,atual_branco,atual_preto);
                    if (mate == 0)
                    {
                        novo->fim_jogo=1;
                    }
                }
            }
        }
        *pt=novo;
    }
}


/*Procedimento que aloca as sugestes de jogadas dentro de cada n da rvore*/
void aloca (struct no *arv, struct reg *jog,int vez, int Mat_Tabuleiro[][8], int nivel_arvore)
{
int x=0;
    /*Insere a rvore nos devidos lugares*/
    while (jog != NULL)
    {
        x=jog->conteudo;
        if (arv->f1==NULL)
        {
            cria_no(&arv->f1,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f2==NULL)
        {
            cria_no(&arv->f2,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f3==NULL)
        {
            cria_no(&arv->f3,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f4==NULL)
        {
            cria_no(&arv->f4,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f5==NULL)
        {
            cria_no(&arv->f5,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f6==NULL)
        {
            cria_no(&arv->f6,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f7==NULL)
        {
            cria_no(&arv->f7,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f8==NULL)
        {
            cria_no(&arv->f8,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f9==NULL)
        {
            cria_no(&arv->f9,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f10==NULL)
        {
            cria_no(&arv->f10,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f10==NULL)
        {
            cria_no(&arv->f11,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f11==NULL)
        {
            cria_no(&arv->f11,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f12==NULL)
        {
            cria_no(&arv->f12,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f13==NULL)
        {
            cria_no(&arv->f13,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f14==NULL)
        {
            cria_no(&arv->f14,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f15==NULL)
        {
            cria_no(&arv->f15,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f16==NULL)
        {
            cria_no(&arv->f16,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f17==NULL)
        {
            cria_no(&arv->f17,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f18==NULL)
        {
            cria_no(&arv->f18,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f19==NULL)
        {
            cria_no(&arv->f19,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        else  if (arv->f20==NULL)
        {
            cria_no(&arv->f20,vez,Mat_Tabuleiro,x,nivel_arvore);
        }
        jog=jog->prox;
    }
}


/*Procedimento que percorre a rvore e verifica se  possvel gerar novas jogadas na rvore desejada*/
void Imprimir(struct no *pt, int atual_branco, int atual_preto,int lances, int nivel_arvore, int vez)
{
struct reg *jog=NULL;
int cont_vez,x,y;
int M[8][8];

    if (vez == 0)
    {
        cont_vez=1;
    }
    else
    {
        cont_vez=0;
    }

    if (pt!=NULL)
    {
        /*A rvore comea a ser gerada a partir do nvel 1, pois o nvel 0  o estado atual e j foi gerado como raiz*/
        if (nivel_arvore <=3 && pt->fim_jogo==0)
        {
            for (x=0;x<=7;x++)
            {
                for (y=0;y<=7;y++)
                {
                    M[x][y]= pt->tabuleiro[x][y];
                }
            }
            /*Chama as funes de gerar jogadas e alocar jogadas geradas*/
            jog=verifica_jogada(vez, M, atual_branco, atual_preto, lances+1);
            aloca(pt, jog, vez, M, nivel_arvore);
        }

        Imprimir(pt->f1,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f2,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f3,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f4,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f5,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f6,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f7,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f8,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f9,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f10,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f11,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f12,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f13,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f14,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f15,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f16,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f17,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f18,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f19,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
        Imprimir(pt->f20,atual_branco,atual_preto,lances,nivel_arvore+1,cont_vez);
    }
}

/*Funo que libera a Arvore*/
struct no * Liberar(struct no **pt){
 /*Verifica se a arvore nao est vazia*/
  if ((*pt)!= NULL){
  Liberar(&(*pt)->f1);
  Liberar(&(*pt)->f2);
  Liberar(&(*pt)->f3);
  Liberar(&(*pt)->f4);
  Liberar(&(*pt)->f5);
  Liberar(&(*pt)->f6);
  Liberar(&(*pt)->f7);
  Liberar(&(*pt)->f8);
  Liberar(&(*pt)->f9);
  Liberar(&(*pt)->f10);
  Liberar(&(*pt)->f11);
  Liberar(&(*pt)->f12);
  Liberar(&(*pt)->f13);
  Liberar(&(*pt)->f14);
  Liberar(&(*pt)->f15);
  Liberar(&(*pt)->f16);
  Liberar(&(*pt)->f17);
  Liberar(&(*pt)->f18);
  Liberar(&(*pt)->f19);
  Liberar(&(*pt)->f20);
  free(*pt);
  }
  return NULL;
}

/*Funo que analisa e gera as jogadas possveis da rvore de jogadas*/
struct reg* verifica_jogada (int vez,int M[][8],int atual_branco, int atual_preto, int qtde_lances)
{
int x,y, a,b, e,f, l,m; /*Auxiliares para loop*/
int guarda[6]={0,0,0,0,0,0};
int valida,mate=0,xeque; /*Validao de movimento, verifica mate, verifica xeque*/
int guarda_melhor,auxiliar,temporaria; /*Auxiliares*/
int mel_rei[2]={0,0}, mel_rainha[2]={0,0}, mel_cavalo[2]={0,0}, mel_bispo[2]={0,0},mel_torre[2]={0,0},mel_peao[2]={0,0}; /*Guarda as posies de uma boa jogada com movimento visando ataque e movimento visando no captura*/
Jogada *novo=NULL,*aux=NULL,*tmp=NULL; /*Lista ligada de jogadas sugeridas, varivel auxiliar*/

    /*Abertura do jogo*/
    if (qtde_lances <=2)
    {
        for (x=0;x<=7;x++)
        {
            for (y=0;y<=7;y++)
            {
                if (M[x][y] != 0 && M[x][y] %10 == 0)
                {
                    /*Mover peo para o Centro*/
                    if (M[4][3] != 0 || M[4][5] != 0 || M[3][3] != 0 || M[3][5] != 0 || M[3][4] != 0 )
                    {
                        guarda[0]=1;
                    }
                    if (M[4][2] != 0 || M[4][4] != 0 )
                    {
                        guarda[1]=1;
                    }
                    if (M[4][1] != 0 || M[4][3] != 0 )
                    {
                        guarda[2]=1;
                    }
                    if (M[4][4] != 0 || M[4][6] != 0 )
                    {
                        guarda[3]=1;
                    }
                    if (M[4][0] != 0 || M[4][2] != 0 )
                    {
                        guarda[4]=1;
                    }
                    if (M[4][5] != 0 || M[4][7] != 0 )
                    {
                        guarda[5]=1;
                    }
                }
            }
        }
         novo= (Jogada *) malloc( sizeof( Jogada ));
        /*Retorna jogada vlida*/
        if (guarda[0] != 1){novo->conteudo = 1434;}
        else if (guarda[1] != 1){novo->conteudo =  1333;}
        else if (guarda[2] != 1){novo->conteudo = 1232;}
        else if (guarda[3] != 1){novo->conteudo = 1535;}
        else if (guarda[4] != 1){novo->conteudo = 1131;}
        else if (guarda[5] != 1){novo->conteudo = 1636;}

        return (novo);
    }

    /*Meio e Fim do Jogo*/
    else
    {

        /*Loop para verificar se h algum pea no tabuleiro*/
        for (x=0;x<=7;x++)
        {
            for (y=0;y<=7;y++)
            {
                /*DEFESA - Verifica se h alguma pea do inimigo no tabuleiro*/
                if (M[x][y] % 10 !=vez && M[x][y] != 0)
                {
                    /*Verifica se eu posso me defender de algum ataque*/
                    for (a=0;a<=7;a++)
                    {
                        for (b=0;b<=7;b++)
                        {
                            auxiliar=0;
                            /*Verifica se h alguma pea que pode ser atacada por uma pea inimiga*/
                            if (M[a][b] != 0 && M[a][b] % 10 == vez && ((valida=valida_movimento(x*10+y,a*10+b,M) == 1)))
                            {
                                /*Tenta fugir */
                                for (e=0;e<8;e++)
                                {
                                    for (f=0;f<8;f++)
                                    {
                                        /*Verifica se o movimento  vlido, se a nova posio est vazia e se essa nova posio est ameaada*/
                                        if (((valida=valida_movimento(a*10+b,e*10+f,M) == 1)) && M[e][f] ==0 && ((mate=valida_movimento(x*10+y,e*10+f,M) != 1)))
                                        {
                                            M[e][f]=M[a][b];
                                            M[a][b]=0;
                                            auxiliar=e*10+f;
                                            e=8;
                                            f=8;
                                        }
                                    }
                                }

                                /*Se foi encontrado um modo de escapar de um ataque, verifica se colocar o prprio rei em xeque*/
                                if (auxiliar!=0)
                                {
                                    mate=1;
                                    /*Verifica se o prprio rei est em Xeque. Caso sim, Invalide a defesa proposta*/
                                    for (e=0;e<8;e++)
                                    {
                                        for (f=0;f<8;f++)
                                        {
                                            xeque=verifica_xeque(M,vez,e,f,atual_branco,atual_preto);
                                            if (xeque == -1)
                                            {
                                                mate=0;
                                                e=8;
                                                f=8;
                                            }
                                        }
                                    }
                                    M[a][b]=M[auxiliar/10][auxiliar%10];
                                    M[auxiliar/10][auxiliar%10]=0;
                                }
                                /*Condio que valida a jogada, pois no resulta em xeque e  possvel fugir do ataque*/
                                if (auxiliar !=0 && mate !=0)
                                {
                                    /*Insere a sugesto de jogada em uma lista ligada (Posio atual e prxima prosio)*/
                                    if (aux == NULL)
                                    {
                                        novo= (Jogada *) malloc( sizeof( Jogada ));
                                        novo->conteudo = a*1000+b*100+auxiliar;
                                        gotoxy(1,1);
                                        novo->prox = NULL;
                                        aux=novo;
                                    }
                                    else
                                    {
                                        tmp=aux;
                                        novo= (Jogada *) malloc( sizeof( Jogada ));
                                        novo->conteudo = a*1000+b*100+auxiliar;
                                        while (tmp->prox != NULL)
                                        {
                                            tmp=tmp->prox;
                                        }
                                        novo->prox = NULL;
                                        tmp->prox=novo;
                                    }
                                }
                            }
                        }
                    }
                }

                /*ATAQUE ou MOVIMENTAO */
                else if (M[x][y] % 10 ==vez && M[x][y] != 0)
                {
                    guarda_melhor=0;
                    auxiliar=0;
                    mate=1;

                    /*Verifica se eu posso captura alguma pea*/
                    for (a=0;a<=7;a++)
                    {
                        for (b=0;b<=7;b++)
                        {
                            /*Verifica se h alguma pea inimiga que pode ser atacada*/
                            if (M[a][b] != 0 && M[a][b] % 10 != vez && ((valida=valida_movimento(x*10+y,a*10+b,M)))==1)
                            {
                                /*Verifica se a posio atual do rei foi alterada*/
                                if (M[x][y] == 60)
                                {
                                    guarda_melhor=atual_branco;
                                    atual_branco=a*10+b;
                                }
                                else if (M[x][y] == 61)
                                {
                                    guarda_melhor=atual_preto;
                                    atual_preto=a*10+b;
                                }
                                auxiliar=M[a][b];
                                M[a][b]=M[x][y];
                                M[x][y]=0;

                                /*Verifica se o ataque pode resultar em um Xeque contra o prprio rei*/
                                for (e=0;e<=7;e++)
                                {
                                    for (f=0;f<=7;f++)
                                    {
                                        /*Verifica se o ataque resultar em um Xeque do prprio rei*/
                                        xeque=verifica_xeque(M,vez,e,f,atual_branco,atual_preto);
                                        if (xeque == -1)
                                        {
                                            mate= -1;
                                            e=8;
                                            f=8;
                                        }
                                    }
                                }
                                M[x][y]=M[a][b];
                                M[a][b]=auxiliar;
                                /*Se a alterao dos rei foi realizada, retorna a posio original para novas verificaes*/
                                if (M[x][y] == 60)
                                {
                                    atual_branco=guarda_melhor;
                                }
                                else if (M[x][y] == 61)
                                {
                                    atual_preto=guarda_melhor;
                                }

                                /*Verifica se a possibilidade de ataque  vlida*/
                                if (valida == 1 && mate != -1)
                                {
                                    /*Retorna a sugesto de jogada (posio da pea que caputou e da capturada) em uma lista ligadas*/
                                    if (aux == NULL)
                                    {
                                        novo= (Jogada *) malloc( sizeof( Jogada ));
                                        novo->conteudo = x*1000+y*100+a*10+b;
                                        novo->prox = NULL;
                                        aux=novo;
                                    }
                                    else
                                    {
                                        tmp=aux;
                                        novo= (Jogada *) malloc( sizeof( Jogada ));
                                        novo->conteudo = x*1000+y*100+a*10+b;
                                        while (tmp->prox != NULL)
                                        {
                                            tmp=tmp->prox;
                                        }
                                        novo->prox = NULL;
                                        tmp->prox=novo;
                                    }
                                 }
                            }

                            /*Verifica se  possvel movimentar a pea*/
                            else if (M[a][b] == 0)
                            {
                                if ((valida=valida_movimento(x*10+y,a*10+b,M))==1)
                                {
                                    M[a][b]=M[x][y];
                                    M[x][y]=0;
                                    auxiliar=0;
                                    /*Verifica Movimentos*/
                                    for (e=0;e<=7;e++)
                                    {
                                        for(f=0;f<=7;f++)
                                        {
                                            if (M[e][f] !=0)
                                            {
                                                /******VERIFICA SE  POSSVEL MOVER UMA PEA, DE MODO QUE ESSA CAPTURE OUTRA PEA NA PRXIMA JOGADA******/
                                                if ((valida=valida_movimento(a*10+b,e*10+f,M))==1)
                                                {
                                                    /*Rainha*/
                                                    if (M[a][b]/10==5)
                                                    {
                                                        /*Se no tiver nenhum outro ataque melhor*/
                                                        if (mel_rainha[0]==0)
                                                        {
                                                            guarda_melhor=mel_rainha[0]%1000/100;
                                                            mel_rainha[0]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                        }
                                                        /*Verifica se a pea a ser capturada  maior do que a que a capturar*/
                                                        else if (M[e][f] /10 >= M[a][b] /10)
                                                        {
                                                            guarda_melhor=mel_rainha[0]%1000/100;
                                                            if (M[e][f] >M[guarda_melhor/10][guarda_melhor%10])
                                                            {
                                                                mel_rainha[0]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                            }
                                                        }
                                                        else if (M[guarda_melhor%100/10][guarda_melhor%10]/10 !=6)
                                                        {
                                                            guarda_melhor=M[e][f];
                                                            M[e][f]=M[a][b];
                                                            M[a][b]=0;
                                                            temporaria=0;
                                                            /*Verifica se eu capturarei e no serei capturado em seguida*/
                                                            for (l=0;l<=7;l++)
                                                            {
                                                                for(m=0;m<=7;m++)
                                                                {
                                                                    if (M[l][m] != 0 &&(valida=valida_movimento(l*10+m,e*10+f,M))==1)
                                                                    {
                                                                        temporaria=1;
                                                                        l=8;
                                                                        m=8;
                                                                    }
                                                                }
                                                            }
                                                            M[a][b]=M[e][f];
                                                            M[e][f]=guarda_melhor;

                                                            /*Insere na rvore caso possa capturar e no seja capturado*/
                                                            if (temporaria==0)
                                                            {
                                                                mel_rainha[0]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                            }

                                                        }
                                                    }
                                                    /*Torre*/
                                                    else if (M[a][b]/10==4 && valida ==1)
                                                    {
                                                        /*Se no tiver nenhum outro ataque melhor*/
                                                        if (mel_torre[0]==0)
                                                        {
                                                            mel_torre[0]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                        }
                                                        /*Verifica se a pea a ser capturada  maior do que a que a capturar*/
                                                        else if (M[e][f] /10 >= M[a][b] /10)
                                                        {
                                                            guarda_melhor=mel_torre[0]%1000/100;
                                                            if (M[e][f] >M[guarda_melhor/10][guarda_melhor%10])
                                                            {
                                                                mel_torre[0]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                            }
                                                        }
                                                    }

                                                    /*Cavalo*/
                                                    else if (M[a][b]/10==3)
                                                    {
                                                        /*Se no tiver nenhum outro ataque melhor*/
                                                        if (mel_cavalo[0]==0)
                                                        {
                                                            mel_cavalo[0]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                        }
                                                        /*Verifica se a pea a ser capturada  maior do que a que a capturar*/
                                                        else if (M[e][f] /10 >= M[a][b] /10)
                                                        {
                                                            guarda_melhor=mel_cavalo[0]%1000/100;
                                                            if (M[e][f] >M[guarda_melhor/10][guarda_melhor%10])
                                                            {
                                                                mel_cavalo[0]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                            }
                                                        }
                                                    }

                                                    /*Bispo*/
                                                    else if (M[a][b]/10==2)
                                                    {
                                                        /*Se no tiver nenhum outro ataque melhor*/
                                                        if (mel_bispo[0]==0)
                                                        {
                                                            mel_bispo[0]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                        }
                                                        /*Verifica se a pea a ser capturada  maior do que a que a capturar*/
                                                        else if (M[e][f] /10 >= M[a][b] /10)
                                                        {
                                                            guarda_melhor=mel_bispo[0]%1000/100;
                                                            if (M[e][f] >M[guarda_melhor/10][guarda_melhor%10])
                                                            {
                                                                mel_bispo[0]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                            }
                                                        }
                                                        else
                                                        {
                                                            guarda_melhor=M[e][f];
                                                            M[e][f]=M[a][b];
                                                            M[a][b]=0;
                                                            temporaria=0;
                                                            /*Verifica se eu capturarei e no serei capturado em seguida*/
                                                            for (l=0;l<=7;l++)
                                                            {
                                                                for(m=0;m<=7;m++)
                                                                {
                                                                    if (M[l][m] != 0 &&(valida=valida_movimento(l*10+m,e*10+f,M))==1)
                                                                    {
                                                                        temporaria=1;
                                                                        l=8;
                                                                        m=8;
                                                                    }
                                                                }
                                                            }
                                                            M[a][b]=M[e][f];
                                                            M[e][f]=guarda_melhor;

                                                            /*Insere na rvore caso possa capturar e no seja capturado*/
                                                            if (temporaria==0)
                                                            {
                                                                mel_bispo[0]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                            }

                                                        }
                                                    }

                                                    /*Peao*/
                                                    else if (M[a][b]/10==1)
                                                    {
                                                        /*Se no tiver nenhum outro ataque melhor*/
                                                        if (mel_peao[0]==0)
                                                        {
                                                            mel_peao[0]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                        }
                                                        /*Verifica se a pea a ser capturada  maior do que a que a capturar*/
                                                        else if (M[e][f] /10 >= M[a][b] /10)
                                                        {
                                                            guarda_melhor=mel_peao[0]%1000/100;
                                                            if (M[e][f] >M[guarda_melhor/10][guarda_melhor%10])
                                                            {
                                                                mel_peao[0]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                            }
                                                        }
                                                    }

                                                }

                                                /******VERIFICA SE  POSSVEL MOVER UMA PEA, DE MODO QUE ESSA NO SEJA CAPTURADA NA PRXIMA JOGADA******/
                                                valida=valida_movimento(e*10+f,a*10+b,M);

                                                /*Rainha*/
                                                if ((valida==1 && M[a][b] /10 == 5 && mel_rainha[1] ==0) || (valida ==0 && M[a][b] /10 == 5 && x*100000+y*10000+a*1000+b*100+e*10+f!= mel_rainha[0]&& auxiliar ==0))
                                                {
                                                    /*Caso no seja possvel se movimentar sem ser capturado, insira na lista de jogadas possveis*/
                                                    if (mel_rainha[1] ==0)
                                                    {
                                                        mel_rainha[1]=x*100000+y*10000+a*1000+b*100+e*10+f;
                                                    }
                                                    /*Condio que verifica se a rainha pode se mover sem ser capturada*/
                                                    else  if (e == 7 && f == 7)
                                                    {
                                                        mel_rainha[1]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                    }
                                                }
                                                /*Torre*/
                                                else if ((valida==1 && M[a][b] /10 == 4 && mel_torre[1] ==0) || (valida ==0 && M[a][b] /10 == 4 && x*100000+y*10000+a*1000+b*100+e*10+f!= mel_torre[0]&& auxiliar ==0))
                                                {
                                                    /*Caso no seja possvel se movimentar sem ser capturado, insira na lista de jogadas possveis*/
                                                    if (mel_torre[1] ==0)
                                                    {
                                                        mel_torre[1]=x*100000+y*10000+a*1000+b*100+e*10+f;
                                                    }
                                                    /*Condio que verifica se a rainha pode se mover sem ser capturada*/
                                                    else  if (e == 7 && f == 7)
                                                    {
                                                        mel_torre[1]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                    }
                                                }
                                                /*Cavalo*/
                                                else if ((valida==1 && M[a][b] /10 == 3 && mel_cavalo[1] ==0) || (valida ==0 && M[a][b] /10 == 3 && x*100000+y*10000+a*1000+b*100+e*10+f!= mel_cavalo[0]&& auxiliar ==0))
                                                {
                                                    /*Caso no seja possvel se movimentar sem ser capturado, insira na lista de jogadas possveis*/
                                                    if (mel_cavalo[1] ==0)
                                                    {
                                                        mel_cavalo[1]=x*100000+y*10000+a*1000+b*100+e*10+f;
                                                    }
                                                    /*Condio que verifica se a rainha pode se mover sem ser capturada*/
                                                    else  if (e == 7 && f == 7)
                                                    {
                                                        mel_cavalo[1]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                    }
                                                }
                                                /*Bispo*/
                                                else if ((valida==1 && M[a][b] /10 == 2 && mel_bispo[1] ==0) || (valida ==0 && M[a][b] /10 == 2 && x*100000+y*10000+a*1000+b*100+e*10+f!= mel_bispo[0]&& auxiliar ==0))
                                                {
                                                    /*Caso no seja possvel se movimentar sem ser capturado, insira na lista de jogadas possveis*/
                                                    if (mel_bispo[1] ==0)
                                                    {
                                                        mel_bispo[1]=x*100000+y*10000+a*1000+b*100+e*10+f;
                                                    }
                                                    /*Condio que verifica se a rainha pode se mover sem ser capturada*/
                                                    else  if (e == 7 && f == 7)
                                                    {
                                                        mel_bispo[1]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                    }
                                                }
                                                /*Peao*/
                                                else if ((valida==1 && M[a][b] /10 == 1 && mel_peao[1] ==0) || (valida ==0 && M[a][b] /10 == 1 && x*100000+y*10000+a*1000+b*100+e*10+f!= mel_peao[0]&& auxiliar ==0))
                                                {
                                                    /*Caso no seja possvel se movimentar sem ser capturado, insira na lista de jogadas possveis*/
                                                    if (mel_peao[1] ==0)
                                                    {
                                                        mel_peao[1]=x*100000+y*10000+a*1000+b*100+e*10+f;
                                                    }
                                                    /*Condio que verifica se a rainha pode se mover sem ser capturada*/
                                                    else  if (e == 7 && f == 7 && b-4)
                                                    {
                                                        mel_peao[1]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                    }
                                                }

                                                /*Rei*/
                                                else if ((valida ==0 && M[a][b] /10 == 6 && x*100000+y*10000+a*1000+b*100+e*10+f!= mel_rei[0]&& auxiliar ==0))
                                                {

                                                    if (e == 7 && f == 7)
                                                    {
                                                        mel_rei[1]= x*100000+y*10000+a*1000+b*100+e*10+f;
                                                    }
                                                }
                                                else
                                                {
                                                    auxiliar=1;
                                                }
                                            }
                                        }
                                    }
                                    M[x][y]=M[a][b];
                                    M[a][b]=0;
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    auxiliar=1;
    while (auxiliar!= 0)
    {
        guarda_melhor=0;
        /*Insere na lista as jogadas que resultam no ataque na prxima jogada*/

        /*Verifica as melhores capturas de cada pea*/
        if (mel_rei[0] != 0)
        {
            guarda_melhor= mel_rei[0];
            mel_rei[0] =0;
        }
        /*Verifica as melhores capturas de cada pea*/
        else if (mel_rainha[0] != 0)
        {
            guarda_melhor= mel_rainha[0];
            mel_rainha[0] =0;
        }
         /*Verifica as melhores capturas de cada pea*/
        else if (mel_torre[0] != 0)
        {
            guarda_melhor= mel_torre[0];
            mel_torre[0] =0;
        }
         /*Verifica as melhores capturas de cada pea*/
        else if (mel_cavalo[0] != 0)
        {
            guarda_melhor= mel_cavalo[0];
            mel_cavalo[0] =0;
        }
         /*Verifica as melhores capturas de cada pea*/
        else if (mel_bispo[0] != 0)
        {
            guarda_melhor= mel_bispo[0];
            mel_bispo[0] =0;
        }
         /*Verifica as melhores capturas de cada pea*/
        else if (mel_peao[0] != 0)
        {
            guarda_melhor= mel_peao[0];
            mel_peao[0] =0;
        }

        /*Insere na lista outras jogadas de movimentao que podem ou no ser atacadas no prximo movimento*/
        else if (mel_rei[1] != 0)
        {
            guarda_melhor= mel_rei[1];
            mel_rei[1] =0;
        }
        else if (mel_rainha[1] != 0)
        {
            guarda_melhor= mel_rainha[1];
            mel_rainha[1] =0;
        }
        else if (mel_torre[1] != 0)
        {
            guarda_melhor= mel_torre[1];
            mel_torre[1] =0;
        }
        else if (mel_cavalo[1] != 0)
        {
            guarda_melhor= mel_cavalo[1];
             mel_cavalo[1] =0;
        }
        else if (mel_bispo[1] != 0)
        {
            guarda_melhor= mel_bispo[1];
            mel_bispo[1] =0;
        }
        else if (mel_peao[1] != 0)
        {
            guarda_melhor= mel_peao[1];
            mel_peao[1] =0;
        }

        /*Insere a sugesto de jogada em uma lista ligada (Posio atual e prxima prosio)*/
        if (guarda_melhor!=0 && aux == NULL)
        {
            novo= (Jogada *) malloc( sizeof( Jogada ));
            novo->conteudo = guarda_melhor/100;
            novo->prox = NULL;
            aux=novo;
        }
        else if (guarda_melhor!=0)
        {
           tmp=aux;
            novo= (Jogada *) malloc( sizeof( Jogada ));
            novo->conteudo = guarda_melhor/100;
            while (tmp->prox != NULL)
            {
                tmp=tmp->prox;
            }
            novo->prox = NULL;
            tmp->prox=novo;
        }
        else
        {
            auxiliar=0;
        }
    }
return(aux);
}

/*Funo que executa o algoritmo Minimax com poda Alfa Beta, visando retornar uma boa jogadas*/
float minimax(struct no *aux_arvore,int profundidade, float alfa, float beta)
{
float min_max,aux_maximo,aux_minimo;
float avaliacao;
int x,y;
int M[8][8];

    if (aux_arvore->f1 == NULL || profundidade == 0)
    {
        /*Caso o n folha for um xeque mate*/
        if (aux_arvore->fim_jogo ==1)
        {
            aux_arvore->avaliacao=10000;
        }
        /*Caso o n folha for um xeque mate*/
        else if (aux_arvore->fim_jogo ==-1 )
        {
             aux_arvore->avaliacao=-10000;
        }
        /*Caso o n folha no for um xeque mate*/
        else
        {
            for (x=0;x<=7;x++)
            {
                for (y=0;y<=7;y++)
                {
                    M[x][y] = aux_arvore->tabuleiro[x][y];
                }
            }
        avaliacao=avalia(M);
        aux_arvore->avaliacao=avaliacao;
        }
        return aux_arvore->avaliacao;
    }
    /*Se a jogada for do time branco, N MIN, retorna o mnimo*/
    if (aux_arvore->TipoNo == 1)
    {
        min_max=1000;
        if (aux_arvore->f1 != NULL){aux_minimo=minimax(aux_arvore->f1,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f2 != NULL){aux_minimo=minimax(aux_arvore->f2,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f3 != NULL){aux_minimo=minimax(aux_arvore->f3,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f4 != NULL){aux_minimo=minimax(aux_arvore->f4,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f5 != NULL){aux_minimo=minimax(aux_arvore->f5,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f6 != NULL){aux_minimo=minimax(aux_arvore->f6,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f7 != NULL){aux_minimo=minimax(aux_arvore->f7,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f8 != NULL){aux_minimo=minimax(aux_arvore->f8,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f9 != NULL){aux_minimo=minimax(aux_arvore->f9,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f10 != NULL){aux_minimo=minimax(aux_arvore->f10,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f11 != NULL){aux_minimo=minimax(aux_arvore->f11,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f12 != NULL){aux_minimo=minimax(aux_arvore->f12,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f13 != NULL){aux_minimo=minimax(aux_arvore->f13,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f14 != NULL){aux_minimo=minimax(aux_arvore->f14,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f15 != NULL){aux_minimo=minimax(aux_arvore->f15,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f16 != NULL){aux_minimo=minimax(aux_arvore->f16,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f17 != NULL){aux_minimo=minimax(aux_arvore->f17,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f18 != NULL){aux_minimo=minimax(aux_arvore->f18,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f19 != NULL){aux_minimo=minimax(aux_arvore->f19,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f20 != NULL){aux_minimo=minimax(aux_arvore->f20,profundidade-1,alfa, beta);
            if (aux_minimo< min_max){min_max=aux_minimo;aux_arvore->avaliacao=min_max;}
            if (min_max < beta){beta=min_max;}
            if (beta <=alfa){return min_max;}}
        return min_max;
    }

     /*Se a jogada for do time branco, N MAX, retorna o mnimo*/
    else
    {
        min_max=-1000;
        if (aux_arvore->f1 != NULL){aux_maximo=minimax(aux_arvore->f1,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f2 != NULL){aux_maximo=minimax(aux_arvore->f2,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f3 != NULL){aux_maximo=minimax(aux_arvore->f3,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f4 != NULL){aux_maximo=minimax(aux_arvore->f4,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f5 != NULL){aux_maximo=minimax(aux_arvore->f5,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f6 != NULL){aux_maximo=minimax(aux_arvore->f6,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f7 != NULL){aux_maximo=minimax(aux_arvore->f7,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f8 != NULL){aux_maximo=minimax(aux_arvore->f8,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f9 != NULL){aux_maximo= minimax(aux_arvore->f9,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f10 != NULL){aux_maximo=minimax(aux_arvore->f10,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f11 != NULL){aux_maximo=minimax(aux_arvore->f11,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
           if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f12 != NULL){aux_maximo=minimax(aux_arvore->f12,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f13 != NULL){aux_maximo=minimax(aux_arvore->f13,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f14 != NULL){aux_maximo=minimax(aux_arvore->f14,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
           if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f15 != NULL){aux_maximo=minimax(aux_arvore->f15,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f16 != NULL){aux_maximo=minimax(aux_arvore->f16,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f17 != NULL){aux_maximo=minimax(aux_arvore->f17,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f18 != NULL){aux_maximo=minimax(aux_arvore->f18,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f19 != NULL){aux_maximo=minimax(aux_arvore->f19,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        if (aux_arvore->f20 != NULL){aux_maximo=minimax(aux_arvore->f20,profundidade-1,alfa, beta);
            if (aux_maximo > min_max){min_max=aux_maximo;aux_arvore->avaliacao=min_max;}
            if (min_max> alfa ){alfa=min_max;}
            if (beta <=alfa){return min_max;}}
        return min_max;
    }
}


